function [W,var0,mu,LP,Cpts] = MCA(X,J)
%MCA Minor Components Analysis
% [W,var0,mu,LP,Cpts] = MCA(X,J)
% Input:
%   X:  D x N matrix, training data. Each column is an data case. Each row is a feature.
%   J:  number of components.
% Output:
%   W:    Selected minor components.
%   var0: noise variance.
%   mu:   mean of X
%   LP:   log-probability of data in the trained BayesXCA model.
%   Cpts: indices of the selected minor components.
%
% Created by Yutian Chen, 2009.

N = size(X, 2);
al = 1e-10 * N; % A weak prior to avoid numerical error when the sample covariance matrix does not have a full rank. 

[W,var0,mu,LP,Cpts] = BayesMCA(X,J,al);
