function [W,var0,mu,LP,Cpts] = ShrinkXCA(X,J,L)
% XCA with the shrinkage method.
%
% Created by Yutian Chen, 2009.

[D,N] = size(X);

LogProb = zeros(J+1,1);

Ic = zeros(J,J+1);

var0_gap = zeros(J+1,1);

mu = mean(X,2);

H = X-repmat(mu,[1,N]);

if ~exist('L','var')

    [s, lamcor, lamvar] = covshrinkKPM(H', 0);

    [U,l] = eig(s);

    L = diag(l);

    [L, idx] = sort(L,'descend');

    U = U(:,idx);

else

    [U, l] = svd(H);

end

for j=1:J+1

    Ic(:,j) = [1:j-1,D-J+j:D]';

    sg2 = L(Ic(:,j));

    var0_gap(j) = sum(L(j:D-J+j-1))/(D-J);

    LogProb(j) = -0.5*N * ( D*log(2*pi*exp(1)) + sum(log(sg2)) + (D-J)*log(var0_gap(j)) );

end

[LP_max,j_max] = max(LogProb);

%j_max = J+1; LP_max = LogProb(j_max); %only PCs
%j_max = 1; LP_max = LogProb(j_max); %only MCs

W =  diag(1 ./ sqrt(L(Ic(:,j_max)))) * U(:,Ic(:,j_max))';

var0 = var0_gap(j_max);

LP = LP_max;

Cpts = Ic(:,j_max);
    
    
    
    
